import assert from 'assert';
import ElGamalKey from '../src/elGamalKey.js';
import utils, { constants } from '../src/utils.js';


var [prv, pub] = ElGamalKey.generate(32);
const prvCopy = ElGamalKey.from(prv.toString());

assert.equal(prv.p.toString(16), prvCopy.p.toString(16));
assert.equal(prv.q.toString(16), prvCopy.q.toString(16));
assert.equal(prv.g.toString(16), prvCopy.g.toString(16));
assert.equal(prv.key.toString(16), prvCopy.key.toString(16));
assert.equal(prv.id, prvCopy.id);
assert.equal(prv.privated, prvCopy.privated);

pub.id = utils.random(constants.one, pub.p.minus(constants.one));
const pubCopy = ElGamalKey.from(pub.toString());

assert.equal(pub.id.toString(16), pubCopy.id.toString(16));
assert.equal(pub.privated, pubCopy.privated);
