import assert from 'assert';
import elGamal from '../src/elGamal.js';
import elGamalKey from '../src/elGamalKey.js';
import utils, { constants } from '../src/utils.js';

//const text = "Hi, it's me, Mario";
//var text = "😜Hi, it's me, Mario🤣";
var text = "也就是Acid House的发展，延伸，因为单独的合成器已经不能满足创作者的表现欲了。融合了更多的合成器电子音色原素，节奏富于变化，内容更加丰富，可以肆无忌惮的融入各种音乐风格，给人前卫，自由，奔放的感觉";
const [prv, pub] = [elGamalKey.from('8mL3DtfnDb4a'), elGamalKey.from('8mL3DtfnC09F')];
//const [prv, pub] = elGamal.generateKeys(24);
const key = pub.p.bitLength();
console.log(prv.toString(), pub.toString())
key
// the key is the error
// 82Ok50kwDTYP/5Yp 82Ok50kwDTaV/jYy
// 8mL3DtfnDb4a 8mL3DtfnC09F
// +Z1bCoFrX6iv +Z1bCoFrCIwR
// /gDDWKy9ZLjc /gDDWKy9N7Xo
// 357jPEYZYRxt 357jPEYZyOS3

//----------------- ENCRYPT -----------------\\
var chunks1 = utils.decode(text, key, 'utf8');
var numbers1 = [];
for (var i = 0; i < chunks1.length; i++) {
    const r = utils.random(constants.zero, pub.p.subtract(constants.one));
    numbers1.push(pub.g.modPow(r, pub.p)); //C1
    numbers1.push(pub.key.modPow(r, pub.p).multiply(chunks1[i]).mod(pub.p)); //C2
}
//console.log(chunks1.map(itm => chunks1.toString(16)))
var share = utils.encode(numbers1, key, 'base64', true)
//----------------- ENCRYPT -----------------\\


//----------------- DECRYPT -----------------\\
var bytes = Buffer.from(share, 'base64');
assert(bytes.length % (key / 8 * 2) === 0, 'Malformed Cipher Text');
var chunks2 = utils.decode(bytes, key);

//ASSERT
for (let i = 0; i < chunks2.length; i++) {
    assert.equal(numbers1[i].toString(16), chunks2[i].toString(16))
}

var numbers2 = [];
for (var i = 0; i < chunks2.length; i += 2) {
    var c1 = chunks2[i];
    var c2 = chunks2[i + 1];
    numbers2.push(c1.modPow(prv.key, prv.p).modInv(prv.p).multiply(c2).mod(prv.p));
}
const msg2 = utils.encode(numbers2, key, 'utf8');
console.log(msg2);

//ASSERT
for (let i = 0; i < chunks1.length; i++) {
    assert.equal(chunks1[i].toString(16), numbers2[i].toString(16))
}


//----------------- DECRYPT -----------------\\

/*
*/
/*
console.log(prv.toString('v2CHtbWaT01F'), pub.toString('v2CHtbWaOsI2'))
const cypherText = elGamal.encrypt(msg, pub);
const secretText = elGamal.decrypt(cypherText, prv);

assert.equal(msg, secretText)
*/
/*
const euro = Buffer.from([0xf0, 0x9f, 0xa4, 0xa3]);
console.log(euro.toString())

var data = Buffer.from('🤣', 'utf8');
console.log(data)
*/
/*
        const chunks = utils.decode(text, key, 'utf8');
        let numbers = [];

        for (let i = 0; i < chunks.length; i++) {
            const r = utils.random(constants.zero, pub.p.subtract(constants.one));
            numbers.push(pub.g.modPow(r, pub.p)); //C1
            numbers.push(pub.key.modPow(r, pub.p).multiply(chunks[i]).mod(pub.p)); //C2
        }

        return utils.encode(numbers, key, 'base64', true)

*/